//+------------------------------------------------------------------+
//|                                          EA_SessionBreak.mq4     |
//|                                                       Digger     |
//+------------------------------------------------------------------+
#property copyright "20100909 0123"
string Ver = "Ver. 2010.09.09 01:23";
extern double LotSize = 0.1;  // 0: calculated from percentOfFreeDepo, other:Fixed lot size 
extern double MinLot = 0.01;  // minimal lot for trading, if calculated lot is less than minimal (it depends on the equity)
extern bool   OptimizeLotSize=True;
extern bool   Anti_DrawDown=True;
extern double Risk=2.0;
extern double TSStepPnt = 1; // TrailingStop Step
//extern int    VolatilityPivotPnt = 130; // 
extern int    VolatilityLowestPnt = 28; // 
extern int    VolatilityDistPnt = 10; // 
//extern int    VolatilityPivotPnt = 50; // 
extern int    VolatilityPeriodDays = 14; // for ATR_Hour_Period (Ex. 14 days * 24 hours = 336)
extern int    ATR_TimeFrame = PERIOD_H1;
extern int    ATR_MA_Method = 0; // 0:SMA; 1:EMA
 int    MagicNumber = 19940728; // MagicNumber
 double ThresholdPnt = 5,Threshold;  // Threshold for the pending order sending
 double Threshold2SendOrder_Modulus = 0.5,Threshold2SendOrder;  // Threshold for the pending order sending
extern double SLPnt = 4; // StopLoss in point. 1point=0.0001 in EURUSD
 double SL; // StopLoss in value 
 double TPPnt = 40,TP; // TakeProfit in point. 1point=0.0001 in EURUSD
 double PPnt  = 2,P; // Breakout points in point. 1point=0.0001 in EURUSD
extern double Spread0PntEURUSD = 1;
extern double Spread0PntGBPUSD = 2;
extern double Spread0PntUSDJPY = 1;
extern double Spread0PntEURJPY = 4;
extern double Spread0PntUSDCHF = 2;
extern double Spread0PntGBPJPY = 9;

 int    AsiaBegin    =  3;   // Open time of the Asian session. -1:Do not trade when this session price has been breaked out. 
 int    AsiaEnd      = 12;   // Close time of the Asian session
 color  AsiaColor    = Seashell; // Color of the Asian session
 int    EurBegin     =  9;   // Open time of the European session. -1:Do not trade when this session price has been breaked out.
 int    EurEnd       = 18;   // Close time of the European session
 color  EurColor     = LightCyan; // Color of the European session
 int    USABegin     = 16;   // Open time of the American session. -1:Do not trade when this session price has been breaked out.
 int    USAEnd       = 1;   // Close time of the American session
 color  USAColor     = LightYellow; // Color of the American session
 int    DayBegin     =  2;   // Open time of the European session. -1:Do not trade when this session price has been breaked out.
 int    DayEnd       =  2;   // Close time of the European session
 color  DayColor     = Black; // Color of the American session
extern bool   ShowSpreads  = true;  // Show the spreads at the left up of the window.
 int    corner       = 1;    // 0 = top left, 1 = top right, 2 = bottom left, 3 = bottom right
extern bool   WriteSpreadsLog  = false;  // true:Write the price data to experts\files.
 int    LotSizeDigits;  // Floating point rounding
 int    PriceDigits;  // Floating point rounding
 int    StopTrading_HourBegin     =  23;   // Open time of the European session. -1:Do not trade when this session price has been breaked out.
 int    StopTrading_HourEnd       =  3;   // Close time of the European session
 int    HourNow;
 
 int    Spread_EMA_Period  = 5;  // The ticks periods by which we calculate the average spread.

double Spread_EMA_Alfa , SpdAVG,TSStep;
double Spread,SpdPnt,Spread0,Spread0Pnt,Spread_EMA=1;

string ObjectVer = "Ver";
string ObjectSpreads = "ShowSpreads";
string sSymbol;
   int digit5;
double maxpeak,Equity,drawdownpercent,drawdown;
double VolatilityLowestVal,VolatilityVal,VolatilityDistVal;
double LotSize_Modulus;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
//----
   int i;

   sSymbol=Symbol();

   LotSizeDigits = MathRound(MathLog(1/MinLot)/MathLog(10)); 
//   LotSizeDigits = 2; 
//Print("INIT"," LotSizeDigits=",LotSizeDigits," PriceDigits=",PriceDigits);
   if(Point==0.001 || Point==0.00001){
      digit5=10;
   }else{
      if(Point==0.01 || Point==0.0001){
         digit5=1;
      }else{
         MessageBox("This EA can only be used on the currency pair which have 2-5 digits price.","Caution",0);
         return(1);
      }
   }
   
   PriceDigits = MathRound(MathLog(1/Point)/MathLog(10));
   Threshold=ThresholdPnt*Point*digit5;  
   Threshold2SendOrder=MathMax(iATR(NULL,PERIOD_H1,200,0)*Threshold2SendOrder_Modulus,10.0*Point*digit5);
   SL=SLPnt*Point*digit5;
   TP=TPPnt*Point*digit5;
   P=PPnt*Point*digit5;
   TSStep=TSStepPnt*Point*digit5;
   Spread_EMA_Alfa = 2.0 /(Spread_EMA_Period + 1);
   Spread_EMA=MarketInfo(sSymbol,MODE_SPREAD)/digit5;
   
//Print("INIT"," LotSizeDigits=",LotSizeDigits," PriceDigits=",PriceDigits);
   if(Period()!=60){
      MessageBox("This EA can only be used on H1(1 hour) time frame.","Caution",0);
      return(1);
   }
   if(sSymbol=="EURUSD"){
      Spread0Pnt=Spread0PntEURUSD;
   }else if(sSymbol=="GBPUSD"){
      Spread0Pnt=Spread0PntGBPUSD;
   }else if(sSymbol=="GBPJPY"){
      Spread0Pnt=Spread0PntGBPJPY;
   }else if(sSymbol=="EURJPY"){
      Spread0Pnt=Spread0PntEURJPY;
   }else if(sSymbol=="USDJPY"){
      Spread0Pnt=Spread0PntUSDJPY;
   }else if(sSymbol=="USDCHF"){
      Spread0Pnt=Spread0PntUSDCHF;
   }else{
      Spread0Pnt=2.0;
   }   
   Spread0=Spread0Pnt*Point*digit5;

//   if (sSymbol=="EURUSD")SpdAVG=1;
   
   
   if( ObjectFind(ObjectVer)==-1) {
      ObjectCreate(ObjectVer,OBJ_LABEL,0,0,0,0,0,0,0);
   }
   ObjectSet(ObjectVer,OBJPROP_CORNER,1);
   ObjectSet(ObjectVer,OBJPROP_XDISTANCE,4);
   ObjectSet(ObjectVer,OBJPROP_YDISTANCE,15);
   ObjectSetText(ObjectVer,Ver,6,"Arial",Black);
   if(ShowSpreads && ObjectFind(ObjectSpreads)==-1) {
      ObjectCreate(ObjectSpreads,OBJ_LABEL,0,0,0,0,0,0,0);
   }
   ObjectSet(ObjectSpreads,OBJPROP_CORNER,corner);
   ObjectSet(ObjectSpreads,OBJPROP_XDISTANCE,111);
   ObjectSet(ObjectSpreads,OBJPROP_YDISTANCE,1);
   ObjectSetText(ObjectSpreads,"Spread=0",9,"Arial",Black);
   
   maxpeak=AccountEquity();
   
   VolatilityLowestVal = VolatilityLowestPnt*Point*digit5;
//   VolatilityPivotVal = VolatilityPivotPnt*Point*digit5;
   VolatilityDistVal=VolatilityDistPnt*Point*digit5;
   VolatilityVal=iCustom(sSymbol,ATR_TimeFrame,"ATRE",PERIOD_D1*VolatilityPeriodDays/ATR_TimeFrame,ATR_MA_Method,0);
   if( VolatilityLowestVal > 0 ){
      LotSize_Modulus = (VolatilityVal - VolatilityLowestVal)/VolatilityDistVal;
      if(LotSize_Modulus>2.0)LotSize_Modulus=2.0;
   }else{
      LotSize_Modulus = 1;
   }

//----
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
// delete comment objects
   int objs = ObjectsTotal();
   string name;
   for(int cnt=ObjectsTotal()-1;cnt>=0;cnt--)
   {
      name=ObjectName(cnt);
      if (StringFind(name,ObjectSpreads,0)>-1 || StringFind(name,ObjectVer,0)>-1) ObjectDelete(name);
      WindowRedraw();
   }
   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
/*
   if(sSymbol!="EURUSD" && sSymbol!="GBPUSD"){
      return(1);
   }
*/
   if(Period()!=60){
      MessageBox("This EA can only be used on H1(1 hour) time frame.","Caution",0);
      return(1);
   }
   Spread_EMA = Spread_EMA_Alfa*MarketInfo(sSymbol,MODE_SPREAD)/digit5 + (1-Spread_EMA_Alfa)*Spread_EMA;
   
//Comment(" Spread_EMA=",DoubleToStr(Spread_EMA,2));

   if (ShowSpreads && !IsTesting()) ProcessTicks(); // ShowSpread. Call the main processing routine.

//************************* For Day **********************
   if (DayBegin>=0)
      if(Order("Dy", DayBegin, DayEnd, DayColor)>0) return(2);

//************************* For Asia Session *********************
   if (AsiaBegin>=0)
      if(Order("As", AsiaBegin, AsiaEnd, AsiaColor)>0) return(1);

//************************* For Europe Session *******************   
   if (EurBegin>=0)
      if(Order("Eu", EurBegin, EurEnd, EurColor)>0) return(1);
       
//************************* For USA Session **********************
   if (USABegin>=0)
      if(Order("Us", USABegin, USAEnd, USAColor)>0) return(1);
}
//+------------------------------------------------------------------+
 
int Order(string SessionName, int SessionBegin, int SessionEnd, color SessionColor) 
{
   int ticket,DaysOrderOpened;
   int err;
   int q=0;
   double L,H,C,O,Check1,Check2,FreeDepo,dAtr,SL_Buy,SL_Sell;
   datetime dtNow;
   int OrderBUYCount,OrderSELLCount;
   //int ATR_TimeFrame[]  =  {0,1,5,15,30,60,240,1440,10080};
   int iDay,iDayPrev,iHour,iMinute,iSessionEndPassedHours,iSessionHours;
//   int iMinutes,iSessionEndPassedPeriods,iSessionPeriods;

   SpdPnt = MarketInfo(sSymbol,MODE_SPREAD)/digit5;
//   Print("Debug Point 01. sSymbol=",sSymbol);
   Spread=SpdPnt*Point*digit5;
   
   if (SessionEnd > SessionBegin) {
      iSessionHours= SessionEnd - SessionBegin;
   } else {
      iSessionHours= SessionEnd + 24 - SessionBegin;
   }
//   iSessionPeriods=iSessionHours*PERIOD_H1*1.0/Period()+0.5;
//===================== Lets determine lot size and risk ===================================
//   Print(" Optimized Risk=",DoubleToStr(Risk,2));            
   if(OptimizeLotSize){
      LotSize=MathPow(AccountEquity(),0.7)*Risk/2000.0;
      if ( SessionName != "Dy" ){
         LotSize = LotSize/2.0;
      }
//   Print(" Optimized Lot Size=",DoubleToStr(LotSize,5)," Risk=",DoubleToStr(Risk,2));            
   }
//   Print(" drawdownpercent=",DoubleToStr(drawdownpercent,1));            
   if(Anti_DrawDown){
      DrawDownCheck();
      if(drawdownpercent>0){LotSize=LotSize*13.0/(10.0+drawdownpercent);}
   }
   if(LotSize<MinLot){
      Print(" No enoghph equity!, LotSize=",DoubleToStr(LotSize,2), " equity=",DoubleToStr(AccountEquity(),2));            
      //return(0);
   }

   //Volatility check
   dtNow = TimeCurrent();
   iDay = TimeDay(dtNow);
   iHour = TimeHour(dtNow);
   iMinute = TimeMinute(dtNow);
   if( VolatilityLowestVal > 0 ){
      if(iHour==0 && iMinute == 0 && iDayPrev != iDay){
         iDayPrev = iDay;
         VolatilityVal=iCustom(sSymbol,ATR_TimeFrame,"ATRE",PERIOD_D1*VolatilityPeriodDays/ATR_TimeFrame,ATR_MA_Method,0);
         if( VolatilityVal <= VolatilityLowestVal) {
            LotSize_Modulus = 0;
            Print(" Volatility(",DoubleToStr(VolatilityVal,PriceDigits),") is too low, Lowest value is ",DoubleToStr(VolatilityLowestVal,PriceDigits)," LotSize_Modulus=",DoubleToStr(LotSize_Modulus,3));            
         }else{
            LotSize_Modulus = (VolatilityVal - VolatilityLowestVal)/VolatilityDistVal;
            if(LotSize_Modulus>2.0)LotSize_Modulus=2.0;
            Print(" Volatility(",DoubleToStr(VolatilityVal,PriceDigits),") is high enough, Lowest value is ",DoubleToStr(VolatilityLowestVal,PriceDigits)," LotSize_Modulus=",DoubleToStr(LotSize_Modulus,3));            
         }
      }
   }else{
      LotSize_Modulus = 1;
   }
   LotSize = LotSize * LotSize_Modulus;
   LotSize=NormalizeDouble(LotSize,2);

//   iMinutes = TimeMinute(dtNow);
   if ( iHour - SessionEnd < 0  ) {
      iSessionEndPassedHours = iHour - SessionEnd + 25 ;
   } else {
      iSessionEndPassedHours = iHour  - SessionEnd + 1 ;
   }
//   iSessionEndPassedPeriods=iSessionEndPassedHours*PERIOD_H1*1.0/Period()+0.5;
//   Comment( "\n","Acceptable risk is ",PercentOfFreeDepo, "% = ",Risk," of the free money ",FreeDepo," in lots = ",Lot);

   L= Low[iLowest(NULL, Period(), MODE_LOW, iSessionHours, iSessionEndPassedHours)]; 
   H= High[iHighest(NULL, Period(), MODE_HIGH, iSessionHours, iSessionEndPassedHours)]; 
   C=iClose(NULL,PERIOD_H1,0);
   O=iOpen(NULL,PERIOD_H1,0);
   Check1=H-C;
   Check2=C-L;
//   SL_Sell=C+dAtr+Spread*2;
//   SL_Buy=C-dAtr-Spread*2;
   SL_Sell=C+(SLPnt+SpdPnt)*Point*digit5;
   SL_Buy=C-(SLPnt+SpdPnt)*Point*digit5;
   
   //====================== checking for the orders expiration and opening
   for( q=0;q<OrdersTotal();q++){
      if (OrderSelect(q, SELECT_BY_POS, MODE_TRADES) && OrderSymbol()==sSymbol){
         // checking positions, if there are some pending orders
         if( (OrderType()==OP_BUYSTOP || OrderType()==OP_SELLSTOP ) && OrderComment() == SessionName ){
            DaysOrderOpened = TimeDayOfYear(dtNow) - TimeDayOfYear(OrderOpenTime());
            if( DaysOrderOpened > 1 || DaysOrderOpened == 1 && TimeHour( dtNow)>= SessionEnd) {
               if( !OrderDelete(OrderTicket(), SessionColor) ){
                  err=GetLastError();
                  Print("Order expiration(24hours) error(",err,")");
               }else{
                  Print("Order deleted at session end. Spread_EMA=",DoubleToStr(Spread_EMA,2));
               }               
            }  
                       
         }else
         if(( OrderType()==OP_BUY || OrderType()==OP_SELL ) 
            && OrderComment() == SessionName ){
            if(OrderType()==OP_BUY ){
               if( SL_Buy - OrderStopLoss() >= TSStep ){
                  if(!OrderModify( OrderTicket(),OrderOpenPrice(), SL_Buy, OrderTakeProfit(), 0, SessionColor)){
                     err=GetLastError();
                     Print("Buy OrderModify error(",err,")");
//Print(" OrderType()=",OrderType()," SL_Buy=",DoubleToStr(SL_Buy,PriceDigits)," OrderStopLoss()=",DoubleToStr(OrderStopLoss(),PriceDigits)," Price=",DoubleToStr(C,PriceDigits)," Spread=",DoubleToStr(Spread,PriceDigits));            
                  }
               }
            }else{
            // OP_SELL
//Print("Symbol=",Symbol()," SL_Sell=",DoubleToStr(SL_Sell,PriceDigits)," OrderStopLoss()=",DoubleToStr(OrderStopLoss(),PriceDigits));            
               if(OrderStopLoss() - SL_Sell >= TSStep ){
                  if(!OrderModify( OrderTicket(),OrderOpenPrice(), SL_Sell, OrderTakeProfit(), 0, SessionColor)){
                     err=GetLastError();
                     Print("Sell OrderModify error(",err,")");
//Print(" OrderType()=",OrderType()," SL_Sell=",DoubleToStr(SL_Sell,PriceDigits)," OrderStopLoss()=",DoubleToStr(OrderStopLoss(),PriceDigits)," Price=",DoubleToStr(C,PriceDigits)," Spread=",DoubleToStr(Spread,PriceDigits));            
                  }
               }
            }
         }
      }  
   }
//=================== condition to delete pending orders ===========================
   HourNow=TimeHour(dtNow);
//======================= condition to open an order ===============================
   if(LotSize<MinLot)return(0);
   OrderBUYCount=0;
   OrderSELLCount=0;
   for( q=0;q<OrdersTotal();q++){
      if (OrderSelect(q, SELECT_BY_POS, MODE_TRADES) && OrderSymbol()==sSymbol){
         // checking positions, if there are some opended orders
         if ( OrderComment() == SessionName ){
            if ( OrderType()==OP_BUYSTOP ){
               OrderBUYCount=1;
            }
            if ( OrderType()==OP_SELLSTOP ){
               OrderSELLCount=1;
            }
         }
      }
   }
//         Comment(SessionName," H=",H," L=",L," H_AfterEnd=",High[iHighest(sSymbol,PERIOD_H1,MODE_HIGH,iSessionEndPassedHours,0)]," L_AfterEnd=",Low[iLowest(sSymbol,PERIOD_H1,MODE_LOW,iSessionEndPassedHours,0)]);
//   if( TimeHour(dtNow) >= SessionEnd && TimeMinute(dtNow) <= 2 ){

   //======================= condition for ORDER BUY ===============================
   if( OrderBUYCount==0 ){ 
//     int iHighest( string symbol, int timeframe, int type, int count=WHOLE_ARRAY, int start=0) 
      if ( H + P + Spread0>= High[iHighest(NULL,PERIOD_H1,MODE_HIGH,iSessionEndPassedHours,0)] ) {
         // The highest price in the session is still the highest

//   Check1=H-C;
//   Check2=C-L;
//Print("OBUYCo1=0"," Price=",DoubleToStr(H+P+Spread0,PriceDigits)," SL=",DoubleToStr(H+P-SL,PriceDigits)," TP=",DoubleToStr(H+P+TP+Spread0,PriceDigits)," Threshold2SendOrder=",DoubleToStr(Threshold2SendOrder,PriceDigits));
         if  (Check1 >= Threshold && O<H && Check1 <= Threshold2SendOrder) {
         
//Print("DBG01  Lot=",DoubleToStr(Lot,2)," LotSizeDigits=",LotSizeDigits," PriceDigits=",PriceDigits);
            ticket=OrderSend(sSymbol,OP_BUYSTOP,LotSize,MathRound((H+P+Spread0)/Point)*Point,0,H+P-SL,H+P+TP+Spread0,SessionName,MagicNumber,0,SessionColor);
//Print(SessionName," price=",H+P+Spread," StopLoss=",H+P-SL+Spread," TakeProfit=",H+P+TP+Spread," SL=",SL," Spread=",Spread);
            if (ticket==-1){
               err=GetLastError();
               Print("BUYSTOP Order Sending error(",err,")");
//Print(" Price=",DoubleToStr(H+P+Spread0,PriceDigits)," SL=",DoubleToStr(H+P-SL,PriceDigits)," TP=",DoubleToStr(H+P+TP+Spread0,PriceDigits));
//Print(" TP=",DoubleToStr(H+P+TP+Spread0,PriceDigits)," H=",DoubleToStr(H,PriceDigits)," P=",DoubleToStr(P,PriceDigits)," TP=",DoubleToStr(TP,PriceDigits)," Spread0=",DoubleToStr(Spread0,PriceDigits));
            }
         }
      }
   }    
   //======================= condition for ORDER SELL ============================= 
   if( OrderSELLCount==0 ){
//      if (SessionName=="Dy")
//         Print(SessionName," L_AfterEnd=",DoubleToStr(Low[iLowest(NULL,PERIOD_H1,MODE_LOW,iSessionEndPassedHours,0)],PriceDigits)," H=",H," L=",L," iSessionHours=",iSessionHours," iSessionEndPassedHours=",iSessionEndPassedHours);

      if ( L - P <= Low[iLowest(NULL,PERIOD_H1,MODE_LOW,iSessionEndPassedHours,0)] ) { 
/*      
         if (SessionName=="Dy")
            Print(SessionName," L_AfterEnd=",DoubleToStr(Low[iLowest(NULL,PERIOD_H1,MODE_LOW,iSessionEndPassedHours,0)],PriceDigits)," H=",H," L=",L);
*/
         // The lowest price in the session is still the lowest
         if  (Check2 >= Threshold && O>L  && Check2 <= Threshold2SendOrder)  {   
//Print("DBG02  Lot=",DoubleToStr(Lot,2)," LotSizeDigits=",LotSizeDigits," PriceDigits=",PriceDigits);
   Print(" Optimized Lot Size=",DoubleToStr(LotSize,2)," Risk=",DoubleToStr(Risk,2));            
            ticket=OrderSend(sSymbol,OP_SELLSTOP,LotSize,MathRound((L-P)/Point)*Point,0,L-P+SL+Spread0,L-P-TP,SessionName,MagicNumber,0,SessionColor);
/*
if(sSymbol=="EURJPY"){
   double LNew=Low[iLowest(sSymbol,PERIOD_H1,MODE_LOW,iSessionEndPassedHours,0)];
   Print(SessionName," NewLow=",DoubleToStr(LNew,PriceDigits)," L=",L);
}
*/
            if (ticket==-1) {
               err=GetLastError();
               Print("SELLSTOP Order Sending error(",err,")");
//Print(" Price=",DoubleToStr(L-P,PriceDigits)," SL=",DoubleToStr(L-P+SL+Spread0,PriceDigits)," TP=",DoubleToStr(L-P-TP,PriceDigits));
//Print(" TP=",DoubleToStr(L-P-TP,PriceDigits)," L=",DoubleToStr(L,PriceDigits)," P=",DoubleToStr(P,PriceDigits)," TP=",DoubleToStr(TP,PriceDigits));
            }
         }else {
//             Comment("\n","Cannot set OP_SELLSTOP","\n","The price is not satisfied to the market entry condition");
         } 
      } 
   }
   return(0);
}
//+------------------------------------------------------------------+
//----------------------------------------------------------------------- 
// Plot and save price information for every tick that arrives.

int   ProcessTicks() {   
   string SpreadString;
   string LogString;
   double AskPrice;   
   double BidPrice;
   
   int      TickLogFileHandle; // Handle for the file open function.
   string   TickLogFileName;// The file to write to.
      
   AskPrice = MarketInfo(sSymbol, MODE_ASK); // Current ASK price for this CurrencyPair
   BidPrice = MarketInfo(sSymbol, MODE_BID); // Current BID price for this CurrencyPair
   
   SpreadString = "Spread=" + DoubleToStr(SpdPnt,1); // Create string to plot on the chart.
   ObjectSetText(ObjectSpreads,SpreadString,9,"Arial",Black);
//   Comment(SpreadString); // Plot the spread on the current chart

   if (WriteSpreadsLog){   
      LogString = 
   //               AccountServer()+ "," + 
                  sSymbol + "," +
                  AskPrice + "," + 
                  BidPrice + "," +
                  DoubleToStr(SpdPnt,1) + "," +
                  DoubleToStr(Spread_EMA,2) + "," +
                  TickTimeStamp();
               
      TickLogFileName =  AccountServer()+ "_" + sSymbol + ".csv"; // Create the name of the log file.             
      TickLogFileHandle = FileOpen(TickLogFileName, FILE_CSV|FILE_READ|FILE_WRITE, ','); // Open the file.
      FileSeek(TickLogFileHandle,0,SEEK_END); // Goto end of log file.                  
      FileWrite(TickLogFileHandle, LogString); // Write the price data.
      FileClose(TickLogFileHandle); // Close the file.
   }
   return(0);
}
   
//----------------------------------------------------------------------- 
// Create a Timestamp string.
string   TickTimeStamp(){      
   string   TimeStamp; // String to return.
   
   TimeStamp = (TimeCurrent()) + "/" +
               ZeroHensyu(TimeMonth(TimeCurrent())) + "/" +
               ZeroHensyu(TimeDay(TimeCurrent())) + " " +
               TimeToStr(TimeCurrent(), TIME_SECONDS);  
   
   return(TimeStamp);
}      
//-------------------------------END------------------------------------- 
string   ZeroHensyu(string str){ 
   while(true)
      if (StringLen(str)>=2)
         return(str);
      else
         str = "0"+str;
}
void DrawDownCheck(){
//---- drawdown check
   Equity=AccountEquity();
   if(maxpeak<Equity) maxpeak=Equity;
   drawdown=maxpeak-Equity;
   if(maxpeak!=0.0){
      drawdownpercent=drawdown/maxpeak*100.0;
   }
}

